#include <Constants.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>


Opt("GUIOnEventMode", 1)

Global $hBmp_Background = _WinAPI_LoadImage(0, @ScriptDir & "\Kaffeetasse.bmp", $IMAGE_BITMAP, 0, 0, $LR_LOADFROMFILE)
Global $aMario[3]
$aMario[0] = _LoadSprite(@ScriptDir & "\Mario1.bmp")
$aMario[1] = _LoadSprite(@ScriptDir & "\Mario2.bmp")
$aMario[2] = _LoadSprite(@ScriptDir & "\Mario3.bmp")

Global $hGui = GUICreate("", 320, 240)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")

Global $hDC = _WinAPI_GetDC($hGui)
Global $hDC_Buffer = _WinAPI_CreateCompatibleDC($hDC)
Global $hBmp_Buffer = _WinAPI_CreateCompatibleBitmap($hDC, 320, 240)
_WinAPI_SelectObject($hDC_Buffer, $hBmp_Buffer)
Global $hDC_Draw = _WinAPI_CreateCompatibleDC($hDC)

GUIRegisterMsg($WM_PAINT, "WM_PAINT")
GUIRegisterMsg($WM_ERASEBKGND, "WM_PAINT")

GUISetState()

_Draw()
_DrawSprite($hDC_Buffer, $aMario[0], 0, 0, 10)
_WinAPI_BitBlt($hDC, 0, 0, 320, 240, $hDC_Buffer, 0, 0, $SRCCOPY)
MsgBox(0, "note", "Sprite has transparent pixels! although it was loaded from a normal BMP-file")

While Sleep(40)
	_Draw()
WEnd



Func _DrawSprite($hDC, $aSprite, $iX, $iY, $fScale = 1)
	If UBound($aSprite) <> 3 Then Return SetError(1, 1, False)
	Return _WinAPI_DrawIconEx($hDC, $iX, $iY, $aSprite[0], $aSprite[1] * $fScale, $aSprite[2] * $fScale)
EndFunc   ;==>_DrawSprite


Func _LoadSprite($sFilename)
	Local $hBMP = _WinAPI_LoadImage(0, $sFilename, $IMAGE_BITMAP, 0, 0, $LR_LOADFROMFILE)
	If @error Or Not $hBMP Then Return SetError(1, 1, False)

	Local $tBitmap = DllStructCreate("long bmType; long bmWidth; long bmHeight; long bmWidthBytes; ushort bmPlanes; ushort bmBitsPixel; ptr bmBits;")
	Local $aResult = DllCall("gdi32.dll", "int", "GetObject", "hwnd", $hBMP, "int", DllStructGetSize($tBitmap), "ptr", DllStructGetPtr($tBitmap))

	Local $tIcon = DllStructCreate("bool Icon; dword XHotSpot; dword YHotSpot; handle hMask; handle hColor")
	DllStructSetData($tIcon, 1, True)
	DllStructSetData($tIcon, 2, 0)
	DllStructSetData($tIcon, 3, 0)
	DllStructSetData($tIcon, 4, $hBMP)
	DllStructSetData($tIcon, 5, $hBMP)
	$aResult = DllCall("user32.dll", "ptr", "CreateIconIndirect", "ptr", DllStructGetPtr($tIcon))
	If @error Or Not $aResult[0] Then
		_WinAPI_DeleteObject($hBMP)
		Return SetError(1, 2, False)
	EndIf
	_WinAPI_DeleteObject($hBMP)

	Local $aReturn[3]
	$aReturn[0] = $aResult[0]
	$aReturn[1] = DllStructGetData($tBitmap, "bmWidth")
	$aReturn[2] = DllStructGetData($tBitmap, "bmHeight")

	Return $aReturn
EndFunc   ;==>_LoadSprite


Func _DestroySprite(ByRef $aSprite)
	If UBound($aSprite) <> 3 Then Return SetError(1, 1, False)
	_WinAPI_DestroyIcon($aSprite[0])
	$aSprite = 0
EndFunc   ;==>_DestroySprite


Func _Draw()
	_WinAPI_SelectObject($hDC_Draw, $hBmp_Background)
	For $x = 0 To 320 Step 128
		For $y = 0 To 240 Step 128
			_WinAPI_BitBlt($hDC_Buffer, $x, $y, 128, 128, $hDC_Draw, 0, 0, $SRCCOPY)
		Next
	Next

	Local Static $iStep = 0, $iX = 10
	$iStep += 1
	If $iStep > 7 Then $iStep = 0
	$iX += 2
	If $iX > 320 Then $iX = -30
	If $iStep < 6 Then
		_DrawSprite($hDC_Buffer, $aMario[Floor($iStep / 2)], $iX, 160, 2)
	Else
		_DrawSprite($hDC_Buffer, $aMario[1], $iX, 160, 2)
	EndIf

	_WinAPI_BitBlt($hDC, 0, 0, 320, 240, $hDC_Buffer, 0, 0, $SRCCOPY)
EndFunc   ;==>_Draw


Func WM_PAINT($hWnd, $uMsgm, $wParam, $lParam)
	_WinAPI_BitBlt($hDC, 0, 0, 320, 240, $hDC_Buffer, 0, 0, $SRCCOPY)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_PAINT


Func _Exit()
	_DestroySprite($aMario[0])
	_DestroySprite($aMario[1])
	_DestroySprite($aMario[2])

	_WinAPI_DeleteObject($hBmp_Buffer)
	_WinAPI_DeleteObject($hBmp_Background)
	_WinAPI_DeleteDC($hDC_Draw)
	_WinAPI_DeleteDC($hDC_Buffer)
	_WinAPI_ReleaseDC($hGui, $hDC)
	Exit
EndFunc   ;==>_Exit